VERSION 5.00
Begin VB.UserControl ExMsgBlast 
   BorderStyle     =   1  'Fixed Single
   CanGetFocus     =   0   'False
   ClientHeight    =   2130
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   2970
   ClipControls    =   0   'False
   InvisibleAtRuntime=   -1  'True
   Picture         =   "ExMsgBlast.ctx":0000
   ScaleHeight     =   142
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   198
   ToolboxBitmap   =   "ExMsgBlast.ctx":00FA
End
Attribute VB_Name = "ExMsgBlast"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

'====================================================
'ExMsgBlast.ctl
'Author: Ben Baird
'Comments: This control was made specifically for
'           the owner-draw menu example on Visual
'           Basic Thunder and the author in no way
'           guarantees its reliability.
'           It is advised that you create your own
'           callback procedure when implementing the
'           owner-draw menu code in one of your
'           applications.
'====================================================

Public Enum exProcType
 exPostProcess
 exPreProcess
 exEatMessage
End Enum

Public InvokeProc As Boolean

'Default Property Values:
Const m_def_ProcessType = 0
Const m_def_hWndUser = 0
'Property Variables:
Dim m_hWndUser As Long
'Event Declarations:
Event MsgProc(ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long, Result As Long)

Private Sub UserControl_Initialize()

Set UserCtl = Me

End Sub


Private Sub UserControl_Resize()

UserControl.Width = (24 * Screen.TwipsPerPixelX)
UserControl.Height = (24 * Screen.TwipsPerPixelY)

End Sub


Public Property Get hWndUser() As Long
Attribute hWndUser.VB_Description = "Gets/sets the hWnd of the object to subclass."
Attribute hWndUser.VB_MemberFlags = "400"
    hWndUser = m_hWndUser
End Property

Public Property Let hWndUser(ByVal New_hWndUser As Long)

    'If Ambient.UserMode = False Then Err.Raise 382

    If New_hWndUser Then
        If m_hWndUser And OldUserProc Then
         Call SetWindowLong(m_hWndUser, GWL_WNDPROC, OldUserProc)
        End If
        OldUserProc = GetWindowLong(New_hWndUser, GWL_WNDPROC)
        Call SetWindowLong(New_hWndUser, GWL_WNDPROC, AddressOf UserProc)
    ElseIf New_hWndUser = 0 And OldUserProc Then
        Call SetWindowLong(m_hWndUser, GWL_WNDPROC, OldUserProc)
    End If

    m_hWndUser = New_hWndUser
    PropertyChanged "hWndUser"

End Property

'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
    m_hWndUser = m_def_hWndUser
    m_ProcessType = m_def_ProcessType
End Sub

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)

    m_hWndUser = PropBag.ReadProperty("hWndUser", m_def_hWndUser)
    m_ProcessType = PropBag.ReadProperty("ProcessType", m_def_ProcessType)
End Sub

Private Sub UserControl_Terminate()

hWndUser = 0

End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

    Call PropBag.WriteProperty("hWndUser", m_hWndUser, m_def_hWndUser)
    Call PropBag.WriteProperty("ProcessType", m_ProcessType, m_def_ProcessType)
End Sub


Public Function ExecProc(ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Attribute ExecProc.VB_MemberFlags = "40"

Dim Res As Long

InvokeProc = True
RaiseEvent MsgProc(hWnd, wMsg, wParam, lParam, Res)
ExecProc = Res

End Function
Public Property Get ProcessType() As exProcType
Attribute ProcessType.VB_Description = "Determines when the MsgProc event will be fired."
    ProcessType = m_ProcessType
End Property

Public Property Let ProcessType(ByVal New_ProcessType As exProcType)
    m_ProcessType = New_ProcessType
    PropertyChanged "ProcessType"
End Property

